/* spec-selector for simplex generic compiler-driver
 *
 * Copyright (c) 2016 Mike Spooner
 * version 1.1 27dec2016 MJS
 */
#if 0

/* Microsoft Visual-C++ 6.0 and 7.0
 */
#elif defined(_MSC_VER) && (_MSC_VER >= 1200) && (_MSC_VER < 1310)
#include "winnt/msvc6/win32.spec"

/* Microsoft Visual-C++ 2003 (aka Visual-C++ 7.1)
 */
#elif defined(_MSC_VER) && (_MSC_VER >= 1310) && (_MSC_VER < 1400)
#include "winnt/msvc2003/win32.spec"

/* Microsoft Visual-C++ 2005 and later */
#elif defined(_MSC_VER) && (_MSC_VER >= 1400)
#include "winnt/msvc2005/win32.spec"

/* Watcom C 10 and later, and OpenWatcom 1.4 and later */
#elif defined(__WATCOMC__) && (__WATCOMC__ >= 1000)
#include "winnt/watcom/win32.spec"

/* Borland C++ 5.0 and later, incl. Embracadero CodeGear versions */
#elif defined(__BORLANDC__) && (__BORLANDC__ >= 0x500)
#include "winnt/borland/win32.spec"

/* Digital Mars C/C++ 8.x and later */
#elif defined(__DMC__) && (__DMC__ >= 0x800)
#include "winnt/digmars/win32.spec"

/* Pelles C */
#elif defined(__POCC__)
#include "winnt/pelles/win32.spec"

/* Orange C */
#elif defined(__ORANGEC__)
#include "winnt/orange/win32.spec"

/* Fabrice Bellards' Tiny C Compiler */
#elif defined(__TINY_C__) || defined(__TINYC__)
#include "winnt/tinycc/win32.spec"

/* LCC-win32 */
#elif defined(__LCC__)
#include "winnt/lcc-win/win32.spec"

/* Turbo C/C++ for DOS */
#elif defined(__TURBOC__)
#if defined(HUGE)
#include "pcdos\\turboc\\huge.spc"
#elif defined(SMALL)
#include "pcdos\\turboc\\small.spc"
#endif

/* MinGW-32 */
#elif defined(__MINGW32__) && !defined(__MINGW64__)
#include "bldr/winnt/mingw/win32.spec"

#else	/* only for testing: */
#error "unrecognised C compiler"
#include "unix/sunc5/sunc5.spec"

#endif


/* filesystem-pathname-format support
 */
#if defined(_WIN32) || defined(_WIN64)
#include "winnt/wntfsn.c"

#elif defined(_DOS) || defined(_PCDOS) || defined(_MSDOS)
#include "winnt/wntfsn.c"	/* pathname semantics are similar enough */

#elif defined(unix) || defined(__unix__) || defined(__unix) || \
	defined(__CYGWIN__) || defined(_POSIX_SOURCE)
#include "unix/unxfsn.c"

#else
#error "unknown pathname semantics"

#endif

