#include <stdio.h>
#include <math.h>

int ccid(void)
	{
	int status = 0;	/* until proven otherwise */
	int majori, minori;
	char *majors, *minors;
	unsigned long v;
	char *note = NULL;

	/* suppress "unused" warnings */
	printf("", majori, minori);
	printf("", majors, minors);
	printf("", v, note);
/* ================================================================== */
	#if 0

/* ------------------------------------------------------------------ */
	#elif defined(__IAR_SYSTEMS_ICC__)
	printf("iar ");
	#if defined(__VER__)
	printf("%i %i", __VER__ / 100, __VER__ % 100);
	#else
	printf("# #");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__TenDRA__) && (__TenDRA__ == 1)
	printf("tendra # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(AZTEC_C) || defined(__AZTEC_C__)
	printf("aztec %i %i\n", __VERSION / 100, __VERSION % 100);

/* ------------------------------------------------------------------ */
	#elif (defined(__RENESAS__) || defined(__HITACHI__)) && \
		(defined(__RENESAS_VERSION__) || defined(__HITACHI_VERSION__))
	v = 0;
	#if defined(__RENESAS_VERSION__)
	v = __RENESAS_VERSION__;
	#elif defined(__HITACHI_VERSION)
	v = __HITACHI_VERSION__;
	#endif
	printf("renesas ");
	if (v <= 0x700)
		{
		majori = (v >> 8) & 0xFF;
		minori = v & 0xFF;
		}
	else if (v < 0x01000000)
		{
		majori = (v >> 12) & 0xF;
		minori = v & 0xFF;
		}
	else
		{
		majori = (v >> 24) & 0xFF;
		minori = (v >> 16) & 0xFF;
		}
	if (v)
		printf("%i %i\n", majori, minori);
	else
		printf("# #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__SUNPRO_C)
	#if __SUNPRO_C <= 0x590
	majori = __SUNPRO_C >> 8;
	minori = __SUNPRO_C >> 4 & 0xF;
	#else
	majori = __SUNPRO_C >> 12;
	minori = ((__SUNPRO_C >> 8) & 0xF) + ((__SUNPRO_C >> 4) & 0xF);
	#endif
	printf("sunpro %i %i\n", majori, minori);

/* ------------------------------------------------------------------ */
	#elif defined(__SUNPRO_CC)
	#if __SUNPRO_CC <= 0x590
	majori = __SUNPRO_CC >> 8;
	minori = __SUNPRO_CC >> 4 & 0xF;
	#else
	majori = __SUNPRO_CC >> 12;
	minori = ((__SUNPRO_CC >> 8) & 0xF) + ((__SUNPRO_CC >> 4) & 0xF);
	#endif
	printf("sunpro %i %i\n", majori, minori);

/* ------------------------------------------------------------------ */
	#elif defined(__BORLANDC__)
	printf("borland ");
	majori = (__BORLANDC__ >> 8) & 0x3F;
	minori = (__BORLANDC__ >> 4) & 0xF;

	if (major <= 0x3)
		;
	else if ((majori == 0x4) && (minori < 5))
		--majori;
	else if ((majori == 0x4) && (minori == 5))
		minori = 0;

	if (__BORLANDC__ >= 0x570)
		{
		switch (__BORLANDC__ >> 4)
			{
		case 0x66: note = "codegear xe4";	;;
		case 0x65: note = "codegear xe3";	;;
		case 0x64: note = "codegear xe2";	;;
		case 0x63: note = "codegear xe";	;;
		case 0x62: note = "codegear 2010";	;;
		case 0x61: note = "codegear 2009";	;;
		case 0x59: note = "codegear 2007";	;;
		case 0x57: note = "codegear 2006";	;;
		default:   note = "codegear #";		;;
			}
		}
	printf("%x %x%s%s\n", majori, minori,
		note ? " : " : ""
		note ? note : "");

/* ------------------------------------------------------------------ */
	#elif defined(__CC65__)
	printf("cc65 %x %x\n",
		(__CC65__ >> 8) & 0x3F, (__CC65__ >> 4) & 0xF;

/* ------------------------------------------------------------------ */
	#elif defined(__COMO_VERSION__) && defined(__COMO__)
	majori = __COMO_VERSION__ / 100;
	minori = (__COMO_VERSION__ % 100) / 10;
	printf("comeau %i %i\n", majori, minori);

/* ------------------------------------------------------------------ */
	#elif defined(__DECC_VER)
	printf("decc %li %li\n",
		__DECC_VER / 10000000UL,
		(__DECC_VER % 10000000UL) / 100000UL);

/* ------------------------------------------------------------------ */
	#elif defined(__DECCXX_VER)
	printf("deccpp %li %li\n",
		__DECCXX_VER / 10000000UL,
		(__DECCXX_VER % 10000000UL) / 100000UL);

/* ------------------------------------------------------------------ */
	#elif defined(__ghs__) && defined(__GHS_VERSION_NUMBER__)
	printf("greenhills %i %i\n",
		__GHS_VERSION_NUMBER__ / 100,
		(__GHS_VERSION_NUMBER__ % 100) / 10);

/* ------------------------------------------------------------------ */
	#elif defined(__FCC_VERSION)
	printf("fujitsu # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__PACIFIC__)
	printf("pacific # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__SASC__)
	printf("sas/c ");
	v = 0;
	if (__SASC__ <= 1)
		#if defined(__VERSION__)
		v = __VERSION__;
		#endif
	else
		v = __SASC__;
	if (v)
		printf("%i %i", __SASC__ >> 8, __SASC__ & 0xFF);
	else
		printf("# #");
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__PGI) && defined(__PGIC__) && defined(__PGIC_MINOR__)
	printf("portland %i %i\n", __PGIC__, __PGIC_MINOR__);

/* ------------------------------------------------------------------ */
	#elif defined(_PACC_VER) && (_PACC_VER >= 0x10000000)
	printf("palm %i %i\n", _PACC_VER >> 28, _PACC_VER >> 20 & 0xFF);

/* ------------------------------------------------------------------ */
	#elif defined(__convexc__)
	printf("convex # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__POCC__) && (__POCC__ > 1)
	printf("pelles %i %i\n", __POCC__ / 100, __POCC__ % 100);

/* ------------------------------------------------------------------ */
	#elif defined(__COMPCERT__)
	printf("compcert # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__IMAGECRAFT__)
	printf("imagecraft # #\n");

/* ------------------------------------------------------------------ */
	/* note: IBM XLC must come before IBM z/OS C */
	#elif defined(__xlc__) || defined(__xlC__)
	printf("ibm_xlc ");
	#if defined(__IBMC__)
	printf("%i %i",  __IBMC__ / 100, (__IBMC__ % 100) / 10);
	#else
	printf("# #");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	/* note: IBM z/OS C must come after IBM XLC */
	#elif defined(__IBMC__) && defined(__COMPILER_VER__)
	printf("ibm_zos %i %i\n",
		(__COMPILER_VER__ >> 24) & 0xF,
		(__COMPILER_VER__ >> 16) & 0xFF);

/* ------------------------------------------------------------------ */
	#elif defined(_CRAYC)
	printf("cray_c ");
	#if defined(_RELEASE)
	printf("%i ", _RELEASE);
	#else
	printf("# ");
	#endif
	#if defined(_RELEASE_MINOR)
	printf("%i", _RELEASE_MINOR);
	#else
	printf("#");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__PATHCC__)
	printf("pathscale %i ", __PATHCC__);
	#if defined(__PATHCC_MINOR__)
	printf("%i", __PATHCC_MINOR__);
	#else
	printf("#");
	#endif
	printf(" : ekopath\n");

/* ------------------------------------------------------------------ */
	#elif defined(__HIGHC__)
	printf("metaware_high # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__MWERKS__)
	printf("metrowerks # # : codewarrior\n");

/* ------------------------------------------------------------------ */
	#elif defined(__MINGW32__) && !defined(__MINGW64__)
	printf("mingw32 %i %i : mingw\n",
		__MINGW32_MAJOR_VERSION, __MINGW32_MINOR_VERSION);

/* ------------------------------------------------------------------ */
	#elif defined(__MINGW64__)
	printf("mingw64 %i %i : mingw\n",
		__MINGW32_VERSION_MAJOR, __MINGW32_VERSION_MINOR);

/* ------------------------------------------------------------------ */
	#elif defined(__KCC) && defined(__KCC_VERSION)
	printf("kai %i %i\n",
		(__KCC_VERSION >> 12),
		(__KCC_VERSION >> 8) & 0xF);

/* ------------------------------------------------------------------ */
	#elif defined(__sgi) && (defined(_COMPILER_VERSION) || defined(_SGI_COMPILER_VERSION))
	#ifdef _SGI_COMPILER_VERSION
	majori = _SGI_COMPILER_VERSION / 100;
	minori = (_SGI_COMPILER_VERSION % 100) / 10;
	#else
	majori = _COMPILER_VERSION / 100;
        minori = (_COMPILER_VERSION % 100) / 10;
	#endif
	printf("sgi %i %i\n", majori, minori);

/* ------------------------------------------------------------------ */
	#elif defined(__INTEL_COMPILER)
	printf("intel %i %i\n",
		__INTEL_COMPILER / 100, (__INTEL_COMPILER % 100) / 10);

/* ------------------------------------------------------------------ */
	#elif defined(__CC_NORCROFT)
	printf("norcroft");
	#if defined(__ARMCC_VERSION)
	majori = (int) floor(__ARMCC_VERSION);
	printf("-arm %i %i", majori, (int) (__ARMCC_VERSION - majori));
	#else
	printf(" # #");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__CC_ARM)
	printf("arm.com ");
	#if defined(__ARMCC_VERSION) VRPBBB
        majori = __ARMCC_VERSION / 100000;
        minori = (__ARMCC_VERSION / 10000) % 10;
        printf("%i %i", majori, minori);
        #else
        printf("# #");
        #endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__DCC__) && (__DCC__ == 1) && defined(__VERSION_NUMBER__)
	printf("diab/c %i %i\n",
		__VERSION_NUMBER__ / 1000,
		(__VERSION_NUMBER__ % 1000) / 100);

/* ------------------------------------------------------------------ */
	#elif defined(__DMC__)
	printf("digital_mars %i %i\n",
		__DMC__ / 100, (__DMC__ % 100) / 10);

/* ------------------------------------------------------------------ */
	#elif defined(__VBCC__)
	printf("vbcc # #\n");

/* ------------------------------------------------------------------ */
	/* note: this reports the "internal" compiler version numbers,
	 * which since openwatcom became available, are not the same
	 * as the openwatcom "package" version number.
	 */
	#elif defined(__WATCOMC__)
	printf("watcom %i %i\n", __WATCOMC__ / 100, __WATCOMC__ % 100);

/* ------------------------------------------------------------------ */
	#elif defined(__ZTC__)
	printf("zortech %i %i\n", __ZTC__ >> 8, (__ZTC__ >> 4) & 0xF);

/* ------------------------------------------------------------------ */
	#elif defined(__SYSC__) && defined(__SYSC_VER__)
	printf("dignus_systems %i %i\n",
		__SYSC_VER__ / 10000, (__SYSC_VER % 10000) / 100);

/* ------------------------------------------------------------------ */
	#elif defined(__DJGPP__) && defined(__MSDOS__)
	printf("djgpp %i ", _DJGPP__);
	#if defined(__DJGPP_MINOR__)
	printf("%i", __DJGPP_MINOR__);
	#else
	printf("#");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__EDG__) && defined(__EDG_VERSION__)
	printf("edg %i %i\n",
		__EDG_VERSION__ / 100, __EDG_VERSION__ % 100);

/* ------------------------------------------------------------------ */
	#elif defined(_MSC_VER)
	printf("microsoft %i %i\n", _MSC_VER / 100, _MSC_VER % 100);

/* ------------------------------------------------------------------ */
	#elif defined(__HP_aCC)
	printf("hp_acc ");
	#if (__HP_aCC == 1)
	printf("1 #");
	#else
	printf("%i %i", __HP_aCC / 10000, (__HP_aCC % 10000) / 100);
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__HP_cc)
	printf("hp_ac # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__TI_COMPILER_VERSION__)
	/* cannot distinguish between the C6K, C2K, C5K,
	 * MSP430, ARM and PRU compilers...
	 */
	printf("ti_cgt %i %i\n",
		(__TI_COMPILER_VERSION__ >> 24) & 0xFFF;
		(__TI_COMPILER_VERSION__ >> 12) & 0xFFF;

/* ------------------------------------------------------------------ */
	#elif defined(THINKC4)
	printf("thinkc 4 #\n");

/* ------------------------------------------------------------------ */
	#elif defined(THINKC3)
	printf("thinkc 3 #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__TURBOC__) && (__TURBOC__ >= 0x200)
	printf("turboc %i %i", (__TURBOC__ >> 8) & 0xFF, __TURBOC__ & 0xFF);
	#if (__TURBOC__ == 0x295)
		printf(" : turbocpp 1 0"); 
	#elif (__TURBOC__ == 0x296)
		printf(" : turbocpp 1 1"); 
	#elif (__TURBOC__ == 0x297)
		printf(" : turbocpp 2 0");
	#else
		printf(": turbocpp # #"); 
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__USLC__)
	printf("usl ");
	#if defined(__SCO_VERSION__) && (__SCO_VERSION__ >= 100000000)
	printf("%i %i : unixware",
		__SCO_VERSION__ / 100000000,
		(__SCO_VERSION__ / 100000000) % 100);
	#else
	printf("# #");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#elif defined(__SNC__)
	printf("snc # # : prodg\n");

/* ------------------------------------------------------------------ */
	#elif defined(__SC__) && (__SC__ > 0x100)
	printf("symantec %i %i\n", (__SC__ >> 8) & 0xFF, __SC__ & 0xFF);

/* ------------------------------------------------------------------ */
	#elif defined(__VOSC__) && (__VOSC__ == 1)
	printf("stratus_vos # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(	__NWCC__)
	printf("nwcc # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__GO32__)
	printf("djgpp 1 #\n");

/* ------------------------------------------------------------------ */
	# if 0	/* Universal (aka U++) is not always a separate compiler */
	#elif defined(_UCC) && defined(_MAJOR_REV) && defined(_MINOR_REV)
	printf("ultimate %i %i\n", _MAJOR_REV, _MINOR_REV);
	#endif

/* ------------------------------------------------------------------ */
	#elif defined(_DICE)
	printf("dice # # : %s\n", "amiga");

/* ------------------------------------------------------------------ */
	#elif defined(SDCC)
	printf("sdcc %i %i\n", (SDCC >> 8) & 0xF, (SDCC >> 4) & 0xF);

/* ------------------------------------------------------------------ */
	/* Clang must be near the end, to come after its' many
	 * adaptations (eg: lcc-win32, pathscale ekopath, etc)
	 */
	#elif defined(__clang__)
	/* note that CLang version ID is often corrupted by
	 * ports or adaptations (eg: "Apple Clang" __clang_major__
	 * symbol doesn't track the original Clang numbers, and so on).
	 */
	majori = minori = -1;
	#if defined(__clang_major__) && defined(__clang_minor__)
	printf("clang %i %i\n", __clang_major__, __clang_minor__);
	#else
	printf("clang # #\n");
	#endif

/* ------------------------------------------------------------------ */
	/* bug: ideally would like to distinguish vanilla LCC from
	 * LCC-win32 and LCC-win64...
	 */
	#elif defined(__LCC__)
	printf("lcc # #\n");

/* ------------------------------------------------------------------ */
	#elif defined(__ACK__)
	printf("amsterdam_compiler_kit # #\n");

/* ------------------------------------------------------------------ */
	/* old intel compiler using nondescript identifiers must be
	 * near the end, to avoid probable misidentification.
	 * note that the newer intel compiler, that has a very distinct
	 * identifier, can be checked much earlier (see above).
	 */
	#elif defined(__ICC) || defined(__ECC)
	printf("intel # #\n");

/* ------------------------------------------------------------------ */
	/* Macintosh Programmers' Workbench */
	#elif (defined(MPW_CPLUS) || defined(MPW_C)) && defined(__MRC__)
	printf("mpw %i %i\n", __MRC__ >> 8, __MRC__ & 0xFF);

/* ------------------------------------------------------------------ */
	#elif defined(MIRACLE)
	printf("miracle # #\n");

/* ------------------------------------------------------------------ */
	/* GNU C must be last, as there are so many adaptations of it
	 * ie: we need to catch MinGW, RSXNT, etc *before* we get here.
	 */
	#elif defined( __GNUC__)
	printf("gnu %i ", __GNUC__);
	#if defined(__GNUC_MINOR__)
	printf("%i", __GNUC_MINOR__);
	#else
	printf("#");
	#endif
	printf("\n");

/* ------------------------------------------------------------------ */
	#else	/* unrecognised */
	status = 1;
	#endif

/* ================================================================== */
	return (status);
	}

/* Others:
Archelon
Apogee
Byte Craft
Ceibo (ceibo.com)
Cosmic SaRL
Custom Computer Services, Inc (CCS)
Dunfield Development Services' Micro-C ??
Mikro-Elektronika mikroC
http://www.fabius.com/
HI-TECH C
Softools, Inc (http://www.softools.com/)
*/
