/* internal private shorthand for common string segments:
 *
 * BEL	\a	input file(s)
 * BS	\b	output file
 * VT	\v	misc value from set (from eg: -i*, -d*, -l*)
 * FF	\f	reserved for future use
 */
#define CC_HEAD		"cc|-Xa|-xCC|-xregs=no%appl|-v|-fd|-mc|-xstrconst|-xO2|-xarch=v7|"
#define CC_TAIL		"[predefs][undefs][incdirs]|-o[obj]|[src]"

/* the spec proper:
 */
#define OBJ_EXT		"o"
#define EXE_EXT		"x"
#define SLL_EXT		"a"

#define C89_SPEC	CC_HEAD "-c|" CC_TAIL
#define	C89X_SPEC	CC_HEAD "-c|" CC_TAIL

#define CC_INCDIR1	"-I\v|"
#define CC_INCDIR	CC_INCDIR1
#define CC_PREDEF1	"-D\v|"
#define CC_PREDEF	CC_PREDEF1
#define CC_UNDEF1	"-U\v|"
#define CC_UNDEF	CC_UNDEF1

#define LNK_SPEC	CC_HEAD "[libdirs]|-o[exe]|[objs]|[libs]"
#undef LNK_LIBDIR1	
#undef LNK_LIBDIR

#define SLL_SPEC	"ar|-rcs|[lib]|[objs]"

#define q_pathname	fq_pathname	/* MSVC likes quoted pathnames */
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>

int runvp(char *arg0, char **args)
	{
	pid_t pid;

	pid = fork();
	if (pid == (pid_t)-1)
		return (-1);
	else if (!pid)	/* child */
		{
		execvp(arg0, args);
		exit(-1);
		}
	else	/* parent */
		{
		int status;
		pid_t got;

		while (1)
			{
			got = waitpid(pid, &status, 0);
			if (got == (pid_t)-1)
				{
				if (errno != EINTR)
					return (-1);
				}
			else
				return(status);
			}
		}
	return (-1);
	}

		
