/* example ANSI C89 code that causes Orange C 6.0.9.1 to crash,
 * unless optimisation is turned off with /O-
 *
 * Replacing the definition-value of XSIZE with a literal constant
 * avoids the crash, as does removing the first case statement.
 */
#include <stdlib.h>

#define XSIZE ((sizeof(unsigned int) / sizeof(unsigned char)))

void xcopy(unsigned char src[XSIZE], unsigned char dest[XSIZE])
	{
	size_t n;

	switch (XSIZE)
		{
	case 8:
		dest[7] = src[7];
		dest[6] = src[6];
		dest[5] = src[5];
		dest[4] = src[4];
		/* fall thru */
	case 4:
		dest[3] = src[3];
		dest[2] = src[2];
		/* fall thru */
	case 2:
		dest[1] = src[1];
		dest[0] = src[0];
		break;
	default:
		/* all other cases of XSIZE */
		for (n = 0; n < XSIZE; ++n)
			dest[n] = src[n];
		break;
		}
	}
