/* generic compiler-driver spec for the Tiny C Compiler
 */

/* internal private shorthand for common string segments:
 */
/* note: do NOT use the -b option, it breaks even trivial programs */
#define CC_HEAD		"tcc|-Wimplicit-function_declaration|"
#define CC_TAIL		"[predefs][undefs][incdirs]|-o[obj]|[src]"

/* the spec proper:
 */
#define OBJ_EXT		"o"
#define EXE_EXT		"exe"
#define SLL_EXT		"a"

#define C89_SPEC	CC_HEAD "-c|" CC_TAIL
#define	C89X_SPEC	CC_HEAD "-c|" CC_TAIL

#define CC_INCDIR1	"-I\v|"
#define CC_INCDIR	CC_INCDIR1
#define CC_PREDEF1	"-D\v|"
#define CC_PREDEF	CC_PREDEF1
#define CC_UNDEF1	"-U\v|"
#define CC_UNDEF	CC_UNDEF1

#define LNK_SPEC	CC_HEAD "[libdirs]|-o[exe]|[objs]|[libs]"
/* although tinycc has -L for libdirs, that only applies to -l */
#undef LNK_LIBDIR1
#undef LNK_LIBDIR

#define SLL_SPEC	"bldr\\winnt\\tinycc\\lib.cmd|[lib]|[objs]"

#define q_pathname	fq_pathname	/* MSVC likes quoted pathnames */

#include <process.h>
#define runvp(arg0, av)	spawnvp(P_WAIT, arg0, av)
