static char **findfiles(const char * const * const places,
	char **filenames)
	{
	char **item;
	const char * const *p;
	#if !defined(LNK_LIBDIR1) || !defined(LNK_LIBDIR)
       	char **newlist;
	static const char *dirsep = "\\";
	FILE *pf;

	newlist = NULL;
	for (item = filenames; item && *item; ++item)
		{
		int found;

		found = 0;
		for (p = places; p && *p && !found; ++p)
			{
			char *pathname;

			pathname = str_dup(*p);
			if ((pathname[strlen(pathname)-1] == ':') &&
				isalpha(pathname[0]))
				{
				; /* unadorned drive-name */
				}
			else if (pathname[strlen(pathname)-1] == *dirsep)
				{
				; /* placename already ends with a separator */
				}
			else if (!strlen(pathname))
				{
				; /* place-name is empty */
				}
			else
				pathname = str_buy(pathname, dirsep);
			pathname = str_buy(pathname, *item);
			pf = fopen(pathname, "r");
			if (pf)	/* found it! */
				{
				found = 1;
				fclose(pf);
				newlist = vec_buy(newlist, pathname);
				}
			xfree(pathname);
			}
		if (!found)
		      	{
		      	fprintf(stderr, "%s error: cannot find file: %s\n",
				me, *item);
			exit(EXIT_FAILURE);
			}
		}
	if (newlist)
		{
	      	filenames = vec_discard(filenames);
		filenames = newlist;
		}
	#endif
	return (filenames);
	}
