@echo off
echo off
:: mjsulib: 'configure' for PCDOS-hosted C-compilers
:: NOTE: Only 1983-vintage MSDOS-2.0 syntax here, please.
:: ------------------------------------------------------------------
set LIBNAME=mjsuh

:: defaults, until proven otherwise:
set _O=.obj
set _X=.exe
set _L=.lib
echo #undef HAVE_LONGLONG 1 >config.h

if %1_==turbo_ goto TURBO
if %1_==turbocc_ goto TURBO

echo Please run '%0' with a parameter:
echo. 
echo turbo     Turbo C 2.01 (huge memory-model output)
echo turbocc   Turbo C++ 1.01 (huge memory-model output)
::
:REM other C compilers to possibly tackle in future
:: TopSpeed C (JPI) (DOS and OS/2)
:: Microsoft QuickC 2.51 (DOS)
echo.
pause
goto END


:TURBO
del /f/q bld%_X% 2>nul
REM tcc -Ibldr -A -ms -d -O -G -k -N -DHUGE -D_PCDOS -ebld%_X% bldr\bld.c
tcc -Ibldr -A -ms -d -k -N -DHUGE -D_PCDOS -ebld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:FAILED
if exist *.bak del *.bak
if exist *.apt del *.apt
if exist *.err del *.err
if exist *%_O% del *%_O%
if exist *.map del *.map
if exist *.tds del *.tds
echo.
echo ERROR: Configure failed!
echo.
REM make sure we return a failure status:
find "failed" < nul:
goto END

:COMMON
if exist bld%_O% del bld%_O%
if exist bldr\bld%_O% del bldr\bld%_O%
if not exist bld%_X% goto FAILED
REM construct mkver program:
.\bld c89 -o mkver%_O% mkver.c
if errorlevel 1 goto FAILED
.\bld link -o mkver%_X% mkver%_O%
if errorlevel 1 goto FAILED
if exist mkver%_O% del mkver%_O%
if not exist mkver%_X% goto FAILED
REM pre-clean folder:
if exist %LIBNAME%%_L% del %LIBNAME%%_L%
if exist *.bak del *.bak
if exist *.apt del *.apt
if exist *.err del *.err
if exist *%_O% del *%_O%
if exist *.map del *.map
if exist *.tds del *.tds
echo.
echo Creating make.bat...
set PC=%%
echo @echo off > make.bat
echo echo off >> make.bat
echo if _%PC%1 == _clean goto CLEAN >> make.bat
echo if _%PC%1 == _distclean goto DISTCLEAN >> make.bat
echo :: >> make.bat
echo :INSTALL >> make.bat
echo :BUILD >> make.bat
echo REM construct pkgver.i, must be first: >> make.bat
echo call bldr\pcdos\vrun.bat .\mkver -s mjsulibver -o pkgver.i dist.inf >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo REM now compile modules: >> make.bat
echo .\bld c89 -i. -o cpystr%_O% cpystr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o error%_O% error.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o getflags%_O% getflags.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89x -i. -o hash_llg%_O% hash_llg.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_lng%_O% hash_lng.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_sht%_O% hash_sht.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_str%_O% hash_str.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hashmap%_O% hashmap.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o lstol%_O% lstol.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o lstos%_O% lstos.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o ltols%_O% ltols.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmbuy%_O% mbmbuy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmclr%_O% mbmclr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmclrb%_O% mbmclrb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmfree%_O% mbmfree.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmhight%_O% mbmhight.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmload%_O% mbmload.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmneed%_O% mbmneed.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmrev%_O% mbmrev.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmrevb%_O% mbmrevb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmsave%_O% mbmsave.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmset%_O% mbmset.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmsetb%_O% mbmsetb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmtstb%_O% mbmtstb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmwidth%_O% mbmwidth.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mem_buy%_O% mem_buy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mem_free%_O% mem_free.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o panic%_O% panic.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o prcname%_O% prcname.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o regexp%_O% regexp.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o remark%_O% remark.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o stols%_O% stols.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o str_dup%_O% str_dup.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o strtos%_O% strtos.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o usage%_O% usage.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecbuy%_O% vecbuy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecdup%_O% vecdup.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecfree%_O% vecfree.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o notmsg%_O% notmsg.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o verstr%_O% verstr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o warning%_O% warning.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o whatami%_O% whatami.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo REM and finally construct the library: >> make.bat
echo call .\bld lib -o %LIBNAME%%_L% *%_O% >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo if not exist %LIBNAME%%_L% goto FAIL >>make.bat
echo echo. >> make.bat
echo echo SUCCESS: built %LIBNAME%%_L% >> make.bat
echo echo. >> make.bat
echo :: >> make.bat
echo :SUCCESS >> make.bat
echo REM make sure we return a success status: >> make.bat
prompt cd $G nul:
echo EXIT | %COMSPEC% /K | find "nul:EXIT" >> make.bat
prompt $P$G$S
echo goto DONE >> make.bat
echo :: >> make.bat
echo :FAIL >> make.bat
echo if exist %LIBNAME%%_L% del %LIBNAME%%_L% >> make.bat
echo echo. >>make.bat
echo echo ERROR: make failed! >>make.bat
echo echo. >>make.bat
echo REM make sure we return a failure status: >> make.bat
prompt find "failed" $L nul:
echo EXIT | %COMSPEC% /K | find "nul:EXIT" >> make.bat
prompt $P$G$S
echo goto DONE >> make.bat
echo :: >> make.bat
echo :CLEAN >> make.bat
echo call bldr\pcdos\vrun.bat if exist %LIBNAME%%_L% del %LIBNAME%%_L% >> make.bat
echo call bldr\pcdos\vrun.bat if exist pkgver.i del pkgver.i >> make.bat
echo call bldr\pcdos\vrun.bat if exist *%_O% del *%_O% >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.bak del *.bak >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.tds del *.tds >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.map del *.map >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.apt del *.apt >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.err del *.err >> make.bat
echo echo. >> make.bat
echo echo SUCCESS: clean >> make.bat
echo echo. >> make.bat
echo goto SUCCESS >>make.bat
echo :: >> make.bat
echo :DISTCLEAN >> make.bat
echo call .\make.bat clean >>make.bat
echo call bldr\pcdos\vrun.bat if exist config.h del config.h >> make.bat
echo call bldr\pcdos\vrun.bat if exist bld%_X% del bld%_X% >> make.bat
echo call bldr\pcdos\vrun.bat if exist mkver%_X% del mkver%_X% >> make.bat
echo echo. >> make.bat
echo echo SUCCESS: distclean >> make.bat
echo echo. >> make.bat
echo REM now delete ourself without triggering command.com error: >> make.bat
echo bldr\pcdos\delly.bat make.bat >>make.bat
echo :: >>make.bat
echo :DONE >>make.bat
echo.
echo Configure succeeded.
echo.
:END
