@echo off
echo off
:: mjsulib: 'configure' for win32-hosted C compilers
:: NOTE: Only 1983-vintage MSDOS-2.0 syntax here, please.
:: ------------------------------------------------------------------
set LIBNAME=mjsu_w32

:: defaults, until proven otherwise:
set _O=.obj
set _X=.exe
set _L=.lib
echo #define HAVE_LONGLONG 1 >config.h

if %1_==mars_ goto MARS
if %1_==borland_ goto BORLAND
if %1_==opwat_ goto WATCOM
if %1_==watcom_ goto WATCOM
:: if %1_==intel_ goto INTEL
if %1_==mingw_ goto MINGW32
if %1_==msvc_ goto MSVC
if %1_==vc2003_ goto VC2003
if %1_==vs2003_ goto VC2003
if %1_==vc2005_ goto VC2005
if %1_==vs2005_ goto VC2005
if %1_==vc2008_ goto VC2005
if %1_==vs2008_ goto VC2005
if %1_==vc2010_ goto VC2005
if %1_==vs2010_ goto VC2005
if %1_==vc2012_ goto VC2005
if %1_==vs2012_ goto VC2005
if %1_==vc2013_ goto VC2005
if %1_==vs2013_ goto VC2005
if %1_==vc2015_ goto VC2005
if %1_==vs2015_ goto VC2005
if %1_==vc2017_ goto VC2005
if %1_==vs2017_ goto VC2005
if %1_==lcc_ goto LCCWIN32
if %1_==pelles_ goto PELLES
if %1_==tiny_ goto TINYCC
if %1_==orange_ goto ORANGE
if %1_==lccwin32_ goto LCCWIN32
:: todo: IBM xl 7.0??, Miracle C 3.x, Intel Power

echo Please run '%0' with a parameter:
echo. 
echo mars      Digital Mars C/C++ 8.x or later
echo borland   Borland C/C++ 5.x or later
echo opwat     OpenWatcom C 1.8 or later
echo watcom    Watcom C 11.0 or later
:: echo intel  Intel ISC
echo mingw     MinGW-32
echo msvc      Microsoft Visual-C++ 6.x and 7.x
echo vc2003    Microsoft Visual-C++ 2003
echo vc2005    Microsoft Visual-C++ 2005, 2008, 2010, 2012, 2015, 2017, etc
echo pelles    Pelles C compiler 8.x or later
echo tiny      Fabrice Bellards' Tiny C Compiler
echo orange    Orange C compiler 6.x or later
echo lccwin32  LCC-WIN32 C compiler
echo.
pause
goto END


:MARS
if exist bld%_X% del bld%_X%
dmc -Dconst= -mn -L/NOMAP -L/NOXREF -L/SILENT -obld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:BORLAND
echo #undef HAVE_LONGLONG > config.h
if exist bld%_X% del bld%_X%
bcc32 -Dconst= -q -ebld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:MSVC
if exist bld%_X% del bld%_X%
cl /G3 /nologo /Febld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:VC2003
if exist bld%_X% del bld%_X%
cl /G5 /nologo /Febld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:VC2005
if exist bld%_X% del bld%_X%
cl /nologo /Febld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:WATCOM
if exist bld%_X% del bld%_X%
wcl386 -q -ecw -ei -zro -s -bt=nt -dconst= -fe=bld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:INTEL - untested
if exist bld%_X% del bld%_X%
icl /Febld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:MINGW32
set _O=.o
set _L=.a
if exist bld%_X% del bld%_X%
gcc -O2 -I. -Ibldr -obld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:LCCWIN32
:: NOTE: lcc-win32 cannot always build working executables, due to bugs in the
:: provided runtime library (file-removal/truncation is unreliable).
if exist bld%_X% del bld%_X%
lc -nw -c -Fobld%_O% bldr\bld.c
lc -Fobld%_X% bld%_O%
if errorlevel 1 goto FAILED
goto COMMON

:PELLES
if exist bld%_X% del bld%_X%
cc /W0 /Febld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:TINYCC
set _O=.o
set _L=.a
if exist bld%_X% del bld%_X%
tcc -Dconst= -obld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:ORANGE
set _O=.o
set _L=.l
if exist bld%_X% del bld%_X%
occ +U /T /Wc -obld%_X% bldr\bld.c
if errorlevel 1 goto FAILED
goto COMMON

:FAILED
if exist *.bak del *.bak
if exist *.apt del *.apt
if exist *.err del *.err
if exist *%_O% del *%_O%
if exist *.map del *.map
if exist *.tds del *.tds
echo.
echo ERROR: Configure failed!
echo.
REM make sure we return a failure status:
find "failed" < nul:
goto END

:COMMON
if exist bld%_O% del bld%_O%
if exist bldr\bld%_O% del bldr\bld%_O%
if not exist bld%_X% goto FAILED
REM construct mkver program:
.\bld c89 -o mkver%_O% mkver.c
if errorlevel 1 goto FAILED
.\bld link -o mkver%_X% mkver%_O%
if errorlevel 1 goto FAILED
if exist mkver%_O% del mkver%_O%
if not exist mkver%_X% goto FAILED
REM pre-clean folder:
if exist %LIBNAME%%_L% del %LIBNAME%%_L%
if exist *.bak del *.bak
if exist *.apt del *.apt
if exist *.err del *.err
if exist *%_O% del *%_O%
if exist *.map del *.map
if exist *.tds del *.tds
echo.
echo Creating make.bat...
set PC=%%
echo @echo off > make.bat
echo echo off >> make.bat
echo if _%PC%1 == _clean goto CLEAN >> make.bat
echo if _%PC%1 == _distclean goto DISTCLEAN >> make.bat
echo :: >> make.bat
echo :INSTALL >> make.bat
echo :BUILD >> make.bat
echo REM construct pkgver.i, must be first: >> make.bat
echo call bldr\pcdos\vrun.bat .\mkver -s mjsulibver -o pkgver.i dist.inf >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo REM now compile modules: >> make.bat
echo .\bld c89 -i. -o cpystr%_O% cpystr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o error%_O% error.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o getflags%_O% getflags.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89x -i. -o hash_llg%_O% hash_llg.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_lng%_O% hash_lng.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_sht%_O% hash_sht.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hash_str%_O% hash_str.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o hashmap%_O% hashmap.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o lstol%_O% lstol.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o lstos%_O% lstos.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o ltols%_O% ltols.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmbuy%_O% mbmbuy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmclr%_O% mbmclr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmclrb%_O% mbmclrb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmfree%_O% mbmfree.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmhight%_O% mbmhight.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmload%_O% mbmload.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmneed%_O% mbmneed.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmrev%_O% mbmrev.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmrevb%_O% mbmrevb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmsave%_O% mbmsave.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmset%_O% mbmset.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmsetb%_O% mbmsetb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmtstb%_O% mbmtstb.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mbmwidth%_O% mbmwidth.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mem_buy%_O% mem_buy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o mem_free%_O% mem_free.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o panic%_O% panic.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o prcname%_O% prcname.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o regexp%_O% regexp.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o remark%_O% remark.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o stols%_O% stols.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o str_dup%_O% str_dup.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o strtos%_O% strtos.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o usage%_O% usage.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecbuy%_O% vecbuy.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecdup%_O% vecdup.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o vecfree%_O% vecfree.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o notmsg%_O% notmsg.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o verstr%_O% verstr.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o warning%_O% warning.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo .\bld c89 -i. -o whatami%_O% whatami.c >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo REM and finally construct the library: >> make.bat
echo call .\bld lib -o %LIBNAME%%_L% *%_O% >> make.bat
echo if errorlevel 1 goto FAIL >> make.bat
echo if not exist %LIBNAME%%_L% goto FAIL >>make.bat
echo echo. >> make.bat
echo echo SUCCESS: built %LIBNAME%%_L% >> make.bat
echo echo. >> make.bat
echo :: >> make.bat
echo :SUCCESS >> make.bat
echo REM make sure we return a success status: >> make.bat
prompt cd $G nul:
echo EXIT | %COMSPEC% /K | find "nul:EXIT" >> make.bat
prompt $P$G$S
echo goto DONE >> make.bat
echo :: >> make.bat
echo :FAIL >> make.bat
echo if exist %LIBNAME%%_L% del %LIBNAME%%_L% >> make.bat
echo echo. >>make.bat
echo echo ERROR: make failed! >>make.bat
echo echo. >>make.bat
echo REM make sure we return a failure status: >> make.bat
prompt find "failed" $L nul:
echo EXIT | %COMSPEC% /K | find "nul:EXIT" >> make.bat
prompt $P$G$S
echo goto DONE >> make.bat
echo :: >> make.bat
echo :CLEAN >> make.bat
echo call bldr\pcdos\vrun.bat if exist %LIBNAME%%_L% del %LIBNAME%%_L% >> make.bat
echo call bldr\pcdos\vrun.bat if exist pkgver.i del pkgver.i >> make.bat
echo call bldr\pcdos\vrun.bat if exist *%_O% del *%_O% >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.bak del *.bak >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.tds del *.tds >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.map del *.map >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.apt del *.apt >> make.bat
echo call bldr\pcdos\vrun.bat if exist *.err del *.err >> make.bat
echo echo. >> make.bat
echo echo SUCCESS: clean >> make.bat
echo echo. >> make.bat
echo goto SUCCESS >>make.bat
echo :: >> make.bat
echo :DISTCLEAN >> make.bat
echo call .\make.bat clean >>make.bat
echo call bldr\pcdos\vrun.bat if exist config.h del config.h >> make.bat
echo call bldr\pcdos\vrun.bat if exist bld%_X% del bld%_X% >> make.bat
echo call bldr\pcdos\vrun.bat if exist mkver%_X% del mkver%_X% >> make.bat
echo echo. >> make.bat
echo echo SUCCESS: distclean >> make.bat
echo echo. >> make.bat
echo REM now delete ourself without triggering command.com error: >> make.bat
echo bldr\pcdos\delly.bat make.bat >>make.bat
echo :: >>make.bat
echo :DONE >>make.bat
echo.
echo Configure succeeded.
echo.
:END
