#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <limits.h>
#include <stdlib.h>
#include "mjsu.h"

static VOID quiknot(UINT ty, const CHAR *pfx, const CHAR *fmt, va_list ap)
	{
	fprintf(stdout, "{%i}%s%s ", ty,
		strlen(pfx) ? " " : "", pfx);
	vfprintf(stdout, fmt, ap);
	fprintf(stdout, "\n");
	}

int main(int ac, char **av)
	{
	SHORT s = SHRT_MIN;
	LONG l = LONG_MAX;
	DOUBLE d = 3.14159265359;
	CHAR *p = "did";
	CHAR **q, **r;
	UINT v = NO, x = NO;
	MBITMAP *(*pbfn)(FILE *pf), *b;
	CHAR *version = str_dup("@(#) wibble	1.1	MJS", YES);

	warning("hello s=%hi l=%li d=%.4f\n%s you [%p][%2.2p] know?",
		s,l,d,p,p,p);
#ifndef NOTALL
	getflags(&ac, &av, "s#,l##,p*,v,x", "<more stuff>",
		&s, &l, &p, &v, &x);
#endif
	if (v)
		remark("::: %s :::", version+4);
	if (x)
		usage("-x was seen, %i", 99);

	remark("long hash = 0x%lX",
		rtw_long_hash((BYTE *)"hello world", 11));
	remark("short hash = 0x%hX",
		rtw_short_hash((BYTE *)"wello horld", 11));
	mem_free(version);

	q = vec_buy(NULL, "one", YES);
	q = vec_buy(q, "two", YES);
	r = vec_dup(q, YES);
	version = mem_buy(NULL, 10, YES);
	q = vec_free(q);
	version = mem_buy(version, 13, NO);
	p = cpystr(version, "Hello ", NULL);
	vec_free(r);
	cpystr(p, "Wor", "ld", "\n", NULL);
	fprintf(stdout, "%s", version);

	p = (char *) whatami();
	warning("I am %s", p);
	remark("%hi 0x%lx %hX",
		strtos("-47;stuff", &p, 10),
		ltols(lstol(0xDEADBEEF)),
		stols(lstos(0xABCD)));
	
	b = mbm_buy(8, 2, YES);
	mbm_set(b);
	remark("bitmap is %i rows by %i columns",
		mbm_height(b), mbm_width(b));
	mbm_set(b);
	mbm_clrb(b, 1, 1);
	mbm_rev(b);
	mbm_setb(b, 2, 1);
	if (mbm_tstb(b, 2, 1))
		remark("bit is set OK");
	mbm_clrb(b, 2, 1);
	mbm_free(mbm_clr(b));

	notifier(quiknot);
	version = mem_free(version);

	pbfn = mbm_load;
	remark("load at [%p], save at [%p]", pbfn, mbm_save);

	error("Seen %i warnings", warning(NULL));
	return (EXIT_SUCCESS);
	}
