/* MJS Portable C Library.
 * Module: internal library-private inter-module declarations
 * @(#) mjsuimpl.h  1.4     26dec2016 MJS
 *
 * Copyright (c) 1989-1997, 2005, 2016 Mike Spooner
 *----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 * Source-code conforms to ANSI standard X3.159-1989.
 *----------------------------------------------------------------------
 */

#ifdef __cplusplus
extern "C" {
#endif

#include "mjsu.h"

/* shared private RTW-hash map table: */
#define hashmap mjphsm
extern const mjs_BYTE hashmap[256];


/* the name by which the current process was invoked, set by getflags(),
 * used as intro to error- and warning-messages:
 */
#define process_name mjpprn
extern mjs_CHAR *process_name;


#define mjsmin(a, b) (((a) < (b)) ? (a) : (b))
#define OCTET_MAX       255U    /* sic */

/* check that the amount of memory needed for the bits of a bitmap 
 * can be represented in a size_t.
 */
#define mbm_check_need mjbmck
mjs_BOOL mbm_check_need(mjs_USHORT height, mjs_USHORT width);

/* compute amount of memory needed for the bits of an MBM-format bitmap, without
 * checking for arithmetic overflow when expressed as a size_t.
 */
#define mbm_need(h, w)          ((((h) * (w)) + 7U) >> 3)


/* internal address of function to display formatted notification messages.
 */
#define mjs_notify mjntif
extern mjs_VOID (*mjs_notify)(UINT type, const CHAR *pfx,
	const CHAR *fmt, va_list ap);


/* refer to library version string, to force it to be included in any users
 * of the library.
 */
#define mjsulibver mjlbvr
extern const mjs_CHAR * const mjsulibver;
static const mjs_CHAR * const * const volatile mjsu_verstr = &mjsulibver;

#ifdef __cplusplus
}
#endif
