/* MJS Portable C Library.
 * Module: warning-message API - vwarning() and warning()
 * @(#) warning.c 1.5 26dec2016
 *
 * Copyright (c) 1991, 2016 Mike Spooner
 *----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 * Source-code conforms to ANSI standard X3.159-1989.
 */
#include "mjsuimpl.h"

static UINT nwarnings = 0;

UINT vwarning(CHAR *fmt, va_list ap)
	{
	if (fmt)
		{
		++nwarnings;
		(*mjs_notify)(WARNING_NOTIFY, "warning: ", fmt, ap);
		}
	return (nwarnings);
	}

UINT warning(CHAR *fmt, ...)
	{
	va_list ap;

	va_start(ap, fmt);
	vwarning(fmt, ap);
	va_end(ap);
	return (nwarnings);
	}
